# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.790985
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from keap_core_v2_client.models.rest_product_option_value import RestProductOptionValue
from typing import Optional, Set
from typing_extensions import Self

class RestProductOption(BaseModel):
    """
    RestProductOption
    """ # noqa: E501
    allow_spaces: Optional[StrictBool] = None
    can_contain_character: Optional[StrictBool] = None
    can_contain_number: Optional[StrictBool] = None
    can_end_with_character: Optional[StrictBool] = None
    can_end_with_number: Optional[StrictBool] = None
    can_start_with_character: Optional[StrictBool] = None
    can_start_with_number: Optional[StrictBool] = None
    display_index: Optional[StrictInt] = None
    id: Optional[StrictStr] = None
    label: Optional[StrictStr] = None
    max_chars: Optional[StrictInt] = None
    min_chars: Optional[StrictInt] = None
    name: Optional[StrictStr] = None
    required: Optional[StrictBool] = None
    text_message: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    values: Optional[List[RestProductOptionValue]] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["allow_spaces", "can_contain_character", "can_contain_number", "can_end_with_character", "can_end_with_number", "can_start_with_character", "can_start_with_number", "display_index", "id", "label", "max_chars", "min_chars", "name", "required", "text_message", "type", "values"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['FIXED', 'VARIABLE']):
            raise ValueError("must be one of enum values ('FIXED', 'VARIABLE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RestProductOption from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in values (list)
        _items = []
        if self.values:
            for _item_values in self.values:
                if _item_values:
                    _items.append(_item_values.to_dict())
            _dict['values'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RestProductOption from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "allow_spaces": obj.get("allow_spaces"),
            "can_contain_character": obj.get("can_contain_character"),
            "can_contain_number": obj.get("can_contain_number"),
            "can_end_with_character": obj.get("can_end_with_character"),
            "can_end_with_number": obj.get("can_end_with_number"),
            "can_start_with_character": obj.get("can_start_with_character"),
            "can_start_with_number": obj.get("can_start_with_number"),
            "display_index": obj.get("display_index"),
            "id": obj.get("id"),
            "label": obj.get("label"),
            "max_chars": obj.get("max_chars"),
            "min_chars": obj.get("min_chars"),
            "name": obj.get("name"),
            "required": obj.get("required"),
            "text_message": obj.get("text_message"),
            "type": obj.get("type"),
            "values": [RestProductOptionValue.from_dict(_item) for _item in obj["values"]] if obj.get("values") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


