# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.790985
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from keap_core_v2_client.models.currency_value import CurrencyValue
from typing import Optional, Set
from typing_extensions import Self

class Transaction(BaseModel):
    """
    Transaction
    """ # noqa: E501
    contact_id: Optional[StrictStr] = Field(default=None, description="Reference to the contact the transaction was for.")
    id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the transaction.")
    is_live: Optional[StrictBool] = Field(default=None, description="true if this is a live transaction, false if the transaction is a test or sandbox transaction.")
    is_successful: Optional[StrictBool] = Field(default=None, description="true if the transaction resulted in a success, false if the transaction resulted in a failure or error.")
    order_id: Optional[StrictStr] = Field(default=None, description="Reference to the order this transaction was for")
    payment_gateway_id: Optional[StrictStr] = Field(default=None, description="Reference to the payment processor to where the transaction attempt was made.")
    payment_id: Optional[StrictStr] = Field(default=None, description="Reference to the payment record that on successful transactions. No reference if the transaction failed.")
    payment_processor_type: Optional[StrictStr] = None
    transaction_amount: Optional[CurrencyValue] = None
    transaction_time: Optional[StrictStr] = Field(default=None, description="ISO date-time of the transaction. e.g 2024-04-28 11:25:44")
    transaction_type: Optional[StrictStr] = Field(default=None, description="The type of transaction. Possible values: CAPTURE, VOID, REFUND, CREDIT, APPROVAL")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["contact_id", "id", "is_live", "is_successful", "order_id", "payment_gateway_id", "payment_id", "payment_processor_type", "transaction_amount", "transaction_time", "transaction_type"]

    @field_validator('payment_processor_type')
    def payment_processor_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['PAYPAL', 'UNSUPPORTED', 'AUTHORIZE', 'EWAY', 'WEPAY', 'STRIPE', 'KEAP_PAY']):
            raise ValueError("must be one of enum values ('PAYPAL', 'UNSUPPORTED', 'AUTHORIZE', 'EWAY', 'WEPAY', 'STRIPE', 'KEAP_PAY')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Transaction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of transaction_amount
        if self.transaction_amount:
            _dict['transaction_amount'] = self.transaction_amount.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Transaction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contact_id": obj.get("contact_id"),
            "id": obj.get("id"),
            "is_live": obj.get("is_live"),
            "is_successful": obj.get("is_successful"),
            "order_id": obj.get("order_id"),
            "payment_gateway_id": obj.get("payment_gateway_id"),
            "payment_id": obj.get("payment_id"),
            "payment_processor_type": obj.get("payment_processor_type"),
            "transaction_amount": CurrencyValue.from_dict(obj["transaction_amount"]) if obj.get("transaction_amount") is not None else None,
            "transaction_time": obj.get("transaction_time"),
            "transaction_type": obj.get("transaction_type")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


